const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const companies = sequelize.define(
    'companies',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

tax_id: {
        type: DataTypes.TEXT,
      
      

      },

registration_number: {
        type: DataTypes.TEXT,
      
      

      },

email: {
        type: DataTypes.TEXT,
      
      

      },

phone: {
        type: DataTypes.TEXT,
      
      

      },

website: {
        type: DataTypes.TEXT,
      
      

      },

address_line1: {
        type: DataTypes.TEXT,
      
      

      },

address_line2: {
        type: DataTypes.TEXT,
      
      

      },

city: {
        type: DataTypes.TEXT,
      
      

      },

state: {
        type: DataTypes.TEXT,
      
      

      },

postal_code: {
        type: DataTypes.TEXT,
      
      

      },

country: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"active",


"inactive"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  companies.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity









    db.companies.hasMany(db.departments, {
      as: 'departments_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });


    db.companies.hasMany(db.job_titles, {
      as: 'job_titles_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });


    db.companies.hasMany(db.work_locations, {
      as: 'work_locations_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });


    db.companies.hasMany(db.employees, {
      as: 'employees_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });



    db.companies.hasMany(db.leave_types, {
      as: 'leave_types_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });



    db.companies.hasMany(db.attendance_policies, {
      as: 'attendance_policies_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });


    db.companies.hasMany(db.work_schedules, {
      as: 'work_schedules_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });




    db.companies.hasMany(db.holidays, {
      as: 'holidays_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });


    db.companies.hasMany(db.expense_categories, {
      as: 'expense_categories_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });




    db.companies.hasMany(db.announcements, {
      as: 'announcements_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });


    db.companies.hasMany(db.api_configs, {
      as: 'api_configs_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });


    db.companies.hasMany(db.audit_logs, {
      as: 'audit_logs_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });



//end loop



    db.companies.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });



    db.companies.hasMany(db.file, {
      as: 'logo',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.companies.getTableName(),
        belongsToColumn: 'logo',
      },
    });


    db.companies.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.companies.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return companies;
};


